--- old/usr/src/uts/common/os/devcfg.c	Mon Nov 26 00:31:48 2012
+++ new/usr/src/uts/common/os/devcfg.c	Mon Nov 26 00:31:48 2012
@@ -5890,6 +5890,13 @@
 		}
 	}
 
+	/*
+	 * dv_mknod places a hold on the dev_info_t for each devfs node
+	 * created.  If we're to succeed in detaching this device, we must
+	 * first release all outstanding references held by devfs.
+	 */
+	(void) devfs_clean(pdip, NULL, DV_CLEAN_FORCE);
+
 	if (i_ddi_detachchild(dip, flags) != DDI_SUCCESS) {
 		if (flags & NDI_DEVI_OFFLINE) {
 			RIO_DEBUG((CE_NOTE, "devi_detach_node: offline failed."
